(function() {
  var isComplete, runSteps, valve,
    __slice = Array.prototype.slice;

  module.exports = valve = function() {
    var flow, steps;
    steps = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return flow = function() {
      var args, callback, _i;
      args = 2 <= arguments.length ? __slice.call(arguments, 0, _i = arguments.length - 1) : (_i = 0, []), callback = arguments[_i++];
      return runSteps.apply(null, [steps].concat(__slice.call(args), [callback]));
    };
  };

  runSteps = function() {
    var args, callback, func, i, next, step, stepErr, stepResults, steps, _i, _len, _results;
    steps = arguments[0], args = 3 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 1) : (_i = 1, []), callback = arguments[_i++];
    if (!steps.length) return callback();
    stepErr = void 0;
    next = function(funcIndex) {
      return function() {
        var err, results;
        err = arguments[0], results = 2 <= arguments.length ? __slice.call(arguments, 1) : [];
        if (err != null) stepErr = err;
        stepResults[funcIndex] = results;
        if (isComplete(stepResults)) {
          if (stepErr != null) {
            return callback(stepErr, stepResults);
          } else if (steps.length > 1) {
            return runSteps.apply(null, [steps.slice(1)].concat(__slice.call(args), [function(err, results) {
              results = __slice.call(stepResults).concat(__slice.call(results));
              return callback(err, results);
            }]));
          } else {
            return callback(stepErr, stepResults);
          }
        }
      };
    };
    step = steps[0];
    if (typeof step === 'function') {
      stepResults = [];
      return step.apply(null, __slice.call(args).concat([next(0)]));
    } else {
      stepResults = new Array(step.length);
      _results = [];
      for (i = 0, _len = step.length; i < _len; i++) {
        func = step[i];
        _results.push(func.apply(null, __slice.call(args).concat([next(i)])));
      }
      return _results;
    }
  };

  isComplete = function(arr) {
    var x, _i, _len;
    for (_i = 0, _len = arr.length; _i < _len; _i++) {
      x = arr[_i];
      if (!x) return false;
    }
    return true;
  };

}).call(this);
