module.exports = valve = (steps...) ->
  flow = (args..., callback) -> runSteps steps, args..., callback

runSteps = (steps, args..., callback) ->
  return callback() unless steps.length
  stepErr = undefined

  next = (funcIndex) ->
    (err, results...) ->
      stepErr = err if err?
      stepResults[funcIndex] = results
      if isComplete stepResults
        if stepErr?
          callback stepErr, stepResults
        else if steps.length > 1
          runSteps steps[1..], args..., (err, results) ->
            results = [stepResults..., results...]
            callback err, results
        else
          callback stepErr, stepResults

  step = steps[0]
  if typeof step is 'function'
    stepResults = []
    step args..., next(0)
  else
    stepResults = new Array(step.length)
    func args..., next(i) for func, i in step

# ## Utility functions

isComplete = (arr) ->
  for x in arr
    return false unless x
  true