assert = require 'assert'

valve = require './src/valve'

exports['test sequential execution'] = ->
  next = (callback) -> process.nextTick callback
  valve(next, next, next) (err, results) ->
    assert.isUndefined err
    assert.eql results, [[], [], []]

  i = 0
  increment = (callback) -> callback(null, ++i)
  valve(increment, increment, increment) (err, results) ->
    assert.isUndefined err
    assert.eql results, [[1], [2], [3]]

exports['test parallel execution'] = ->
  next = (callback) -> process.nextTick callback
  valve(next, [next, next]) (err, results) ->
    assert.isUndefined err
    assert.eql results, [[], [], []]

  i = 0
  increment = (callback) -> setTimeout (-> callback null, ++i), randomInt(5)
  lastIncrement = (callback) ->
    assert.eql i, 2
    callback null, ++i
  valve([increment, increment], lastIncrement) (err, results) ->
    assert.isUndefined err
    assert.match results[0][0], /1|2/
    assert.match results[1][0], /1|2/
    assert.eql results[2], [3]

randomInt = (max) -> Math.floor Math.random() * (max + 1)